GroupDamage 			= {}
GroupDamage.name 		= "GroupDamage"
GroupDamage.version 	= "0.84beta2"

local defaultVarsVer 	= 5
local defaults 			= {
	unitTypeToShow		= "all",
	displayMode			= "dmg",
	numberBarsShown 	= 4,
	infinityMode		= false,	
	panelBgColor 		= {0.2823529541, 0.3960784376, 0.4784313738, 0.7537196279},
	panelHeaderColor 	= {0.5921568871, 0.7882353067, 0.9098039269, 0.6268595457},
	panelBarsColor		= {0.4039215744, 0.6117647290, 0.7176470757, 0.5507436991},
	panelBarsColor2		= {0.2352941185, 0.4784313738, 0.6392157078, 0.5422863364},
	offset				= {["x"] = 1450, ["y"] = 615},
	accountWide			= true,
	fightsToSave		= 100,
	showGroupCheck		= true,
	showOnCombatStart	= false,
	hideDuringCombat	= false,
	hideOnCombatEnd		= false,
	hideAfter			= 10,
	minTimeForHist		= 0,
	
	statsActive			= false,
	statsOffset			={["x"] = 0, ["y"] = 0},
}

function GroupDamage.OnAddOnLoaded(event, addonName)
	if addonName ~= GroupDamage.name then return end	
	EVENT_MANAGER:UnregisterForEvent(GroupDamage.name, EVENT_ADD_ON_LOADED)
	GroupDamage:Initialize()	
end
function GroupDamage:Initialize()
	self:RestoreData() 
	self:SetupAddonMenu()
	self:InitializeCore()
	if GroupDamage.svars.statsActive then GroupDamageStats:Initialize() end	
end
function GroupDamage:RestoreData()
	self.savedVariablesAw = ZO_SavedVars:NewAccountWide("GroupDamageSavedVariables", defaultVarsVer, nil, defaults)
	self.savedVariablesChar = ZO_SavedVars:New("GroupDamageSavedVariables", defaultVarsVer, nil, defaults)
	self.svars = self.savedVariablesChar
	if self.savedVariablesAw.accountWide then
		self.svars = self.savedVariablesAw
	end
end

--DEBUG/TEST---------
local function debugTest(var1, var2)
	--if var1 == "on" then GroupDamage.debugOn = true d("Debug output on!") 
	--elseif var1 == "off" then GroupDamage.debugOn = false d("Debug output off!")
	--else
		--
	--end
	if var1 == "on" then
		d("stats on")
		GroupDamage.svars.statsActive = true
		ReloadUI()
	end
	if var1 == "off" then
		d("stats off")
		GroupDamage.svars.statsActive = false
		ReloadUI()
	end
	if var1 == "show" then
		GroupDamageStats:HidePanel(false)
	end
	if var1 == "hide" then
		GroupDamageStats:HidePanel(true)
	end
	if var1 == "update" then
		GroupDamageStats:TestFillAfterFight()
	end
end
---------------------

local function slashHandler(inputString)
	local GD = GroupDamage
	local input = {string.match(inputString,"^(%S*)%s*(.-)$")}
	local inputs = {}
	for k,v in pairs(input) do
		if v ~= nil and v ~= "" then
			table.insert(inputs, string.lower(v)) 
		end
	end
	
	if inputs[1] == "options" or inputs[1] == "o" then
		GD.LAM:OpenToPanel(GroupDamagePanel)
	elseif inputs[1] == "clear" or inputs[1] == "c" then
		if inputs[2] ~= nil and inputs[2] == "all" or inputs[2] == "a" then
			GD:ClearAll()
		else
			GD:ClearCurrentFight()
		end	
	elseif inputs[1] == "hide" or inputs[1] == "h" then
		GD:HidePanel(true)
	elseif inputs[1] == "show" or inputs[1] == "s" then
		GD:HidePanel(false)		
	elseif (inputs[1] == "bars" or inputs[1] == "b") and tonumber(inputs[2]) ~= nil and tonumber(inputs[2]) < 13 and tonumber(inputs[2]) > 1 then
		GD:ChangeBarSettings(tonumber(inputs[2]))
	elseif inputs[1] == "inf" or inputs[1] == "i" then
		GD:ToggleInfMode()
	elseif inputs[1] == "all" or inputs[1] == "a" then
		GD:ChangeUnitTypeShown("all")
	elseif inputs[1] == "players" or inputs[1] == "p" then
		GD:ChangeUnitTypeShown("players")
	elseif inputs[1] == "group" or inputs[1] == "g" then
		GD:ChangeUnitTypeShown("group")
	
	elseif inputs[1] == "penis" then
		if inputs[3] ~= nil and inputs[2] ~= nil then
			debugTest(inputs[2], inputs[3])
		elseif inputs[2] ~= nil then
			debugTest(inputs[2])
		else
			debugTest()
		end
		
	else
		local colorText = "00FF88"
		local colorCommands = "00FF00"
		ZO_ColorDef:New("00FF00"):Colorize("")
		d(ZO_ColorDef:New(colorText):Colorize("<< GroupDamage help >>"))
		d("Command format: " ..  ZO_ColorDef:New(colorText):Colorize("/gd ") .. ZO_ColorDef:New(colorCommands):Colorize("<command>") )
		d(ZO_ColorDef:New(colorText):Colorize("-- ") ..  ZO_ColorDef:New(colorCommands):Colorize("all/players/group") .. " or " .. ZO_ColorDef:New(colorCommands):Colorize("a/p/g") .. " Filter for unit type.")
		d(ZO_ColorDef:New(colorText):Colorize("-- ") ..  ZO_ColorDef:New(colorCommands):Colorize("clear") .. " or " .. ZO_ColorDef:New(colorCommands):Colorize("c") .. " Clears currently shown combat data.")
		d(ZO_ColorDef:New(colorText):Colorize("-- ") ..  ZO_ColorDef:New(colorCommands):Colorize("inf") .. " or " .. ZO_ColorDef:New(colorCommands):Colorize("i/*") .. " Toggle infinite mode.")
		d(ZO_ColorDef:New(colorText):Colorize("-- ") ..  ZO_ColorDef:New(colorCommands):Colorize("bars <value>") .. " or " .. ZO_ColorDef:New(colorCommands):Colorize("b <value>") .. " Change number of shown bars, can be 2-12." )
		d(ZO_ColorDef:New(colorText):Colorize("-- ") ..  ZO_ColorDef:New(colorCommands):Colorize("show/hide") .. " or " .. ZO_ColorDef:New(colorCommands):Colorize("s/h") .. " Show or hide addon.")
		d(ZO_ColorDef:New(colorText):Colorize("-- ") ..  ZO_ColorDef:New(colorCommands):Colorize("options") .. " or " .. ZO_ColorDef:New(colorCommands):Colorize("o").. " Open settings menu.")
	end
end
SLASH_COMMANDS["/gd"] = slashHandler

EVENT_MANAGER:RegisterForEvent(GroupDamage.name, EVENT_ADD_ON_LOADED, GroupDamage.OnAddOnLoaded)