GroupDamage.unitList 			= {}
GroupDamage.nameIdPairs			= {}
GroupDamage.currentFightData	= {
	["combatStart"] 			= 0,
	["combatStartClock"]		= "",
	["combatEnd"] 				= 0,
	["combatEndClock"] 			= "",
	["lastDmgEvent"]			= 0,
	["lastHealEvent"]			= 0,
	["combatTime"] 				= 0,
	["mainTarget"] 				= {["name"] = "", ["dmgRecieved"] = 0, ["id"] = 0},
	["ranking"] 				= {},
	["rankingHeal"]				= {},
	["units"] 					= {}
}
GroupDamage.combatHistory 		= {}
GroupDamage.panelShownFight		= 0
GroupDamage.displayMode			= "dmg"
GroupDamage.missingGrpVisibile	= false
GroupDamage.panelFragment		= ZO_HUDFadeSceneFragment:New(GroupDamageControl, 200, 0)
GroupDamage.hudScene 			= SCENE_MANAGER:GetScene("hud")
GroupDamage.hudUiScene			= SCENE_MANAGER:GetScene("hudui")
GroupDamage.hudScene:AddFragment(GroupDamage.panelFragment)
GroupDamage.hudUiScene:AddFragment(GroupDamage.panelFragment)

GroupDamage.closeAtMs = nil

function GroupDamage:InitializeCore()	
	self:RestoreVars()
	self:InitializeControls()
	self:RegisterEvents()
end
function GroupDamage:RestoreVars()
	if self.svars.infinityMode then self.panelShownFight = -1 end
	self.displayMode = self.svars.displayMode
end
function GroupDamage:RegisterEvents()
	EVENT_MANAGER:RegisterForEvent(self.name, EVENT_EFFECT_CHANGED, self.onEffectChanged)
	EVENT_MANAGER:RegisterForEvent(self.name, EVENT_PLAYER_COMBAT_STATE, self.onCombatState) 	
	EVENT_MANAGER:RegisterForUpdate(self.name, 500, function(gameTimeMs) GroupDamage.updateHandler() end)
	
	local filters = {
		[self.onCombatEventDmg] = {
			ACTION_RESULT_DAMAGE,
			ACTION_RESULT_DOT_TICK,		
			ACTION_RESULT_BLOCKED_DAMAGE,
			ACTION_RESULT_DAMAGE_SHIELDED
		},
		[self.onCombatEventDmgCrit] = {
			ACTION_RESULT_CRITICAL_DAMAGE,	
			ACTION_RESULT_DOT_TICK_CRITICAL	
		},
		[self.onCombatEventHeal] = {
			ACTION_RESULT_HOT_TICK,
			ACTION_RESULT_HEAL
		},
		[self.onCombatEventHealCrit] = {
			ACTION_RESULT_CRITICAL_HEAL,
			ACTION_RESULT_HOT_TICK_CRITICAL
		}
	}
	local nsInc = 1
	for k,v in pairs(filters) do
		for i=1, #v do
			EVENT_MANAGER:RegisterForEvent(self.name..nsInc, EVENT_COMBAT_EVENT, k)
			EVENT_MANAGER:AddFilterForEvent(self.name..nsInc, EVENT_COMBAT_EVENT, REGISTER_FILTER_COMBAT_RESULT , v[i], REGISTER_FILTER_IS_ERROR, false)
			nsInc = nsInc+1
		end	
	end
end


local extraBuffer = {0,0}
function GroupDamage.updateHandler()	
	if extraBuffer[1] > 0 then --every second interval
		GroupDamage:UpdateCombatData()
		GroupDamage:OrderCurrentRanking()
		
		if GroupDamage.closeAtMs ~= nil and GetGameTimeMilliseconds() > GroupDamage.closeAtMs then GroupDamage:HidePanel(true) GroupDamage.closeAtMs = nil end
		
		extraBuffer[1] = 0
	else extraBuffer[1] = 1 end
	
	if extraBuffer[2] > 1 then --every third interval
		GroupDamage:FillMainTarget()
		GroupDamage:UpdateMissingGroupMembers()
		GroupDamage:ClearOldFights()
		
		extraBuffer[2] = 0
	else extraBuffer[2] = extraBuffer[2] + 1 end
	
	GroupDamage:UpdatePanel()
end

--COMBAT STATE HANDLER(old)
local function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end
function GroupDamage.onCombatState(eventCode, inCombat)
	if inCombat then
		GroupDamage.control.infoArea.combatDuration:SetColor(1,0.7,0.3,1)
		if not GroupDamage.svars.infinityMode then
			if GroupDamage.currentFightData["mainTarget"]["dmgRecieved"] ~= 0 and GroupDamage.currentFightData["combatTime"] >= GroupDamage.svars.minTimeForHist*1000 then
				table.insert(GroupDamage.combatHistory, 1, deepcopy(GroupDamage.currentFightData))
			end
			GroupDamage:ClearCurrentFight()
			if GroupDamage.panelShownFight ~= 0 then GroupDamage.panelShownFight = GroupDamage.panelShownFight+1 end
		end
		if GroupDamage.currentFightData["combatStart"] == 0 then
			GroupDamage.currentFightData["combatStart"] = GetGameTimeMilliseconds()
			GroupDamage.currentFightData["combatStartClock"] = GetTimeString()
		end		
	else
		GroupDamage.control.infoArea.combatDuration:SetColor(1,1,1,1)
		if not GroupDamage.svars.infinityMode then
			GroupDamage.currentFightData["combatEnd"] = GetGameTimeMilliseconds()
			GroupDamage.currentFightData["combatEndClock"] = GetTimeString()
			GroupDamage.currentFightData["combatTime"] = GroupDamage.currentFightData["combatEnd"] - GroupDamage.currentFightData["combatStart"]
		end		
		GroupDamage:UpdateCombatData()
		GroupDamage:OrderCurrentRanking()
		GroupDamage:UpdatePanel()

	end
	
	GroupDamage.PanelHideShowCombat(inCombat)
	
	if GroupDamage.svars.statsActive then GroupDamageStats:OnCombatHandler(inCombat) end
end
