--DAMAGE===============
function GroupDamage:DmgDataCom(sourceId, targetId, timeMs, abilityId, hitValue)
	self:CreateUnitArray(sourceId, timeMs)
	self:CreateUnitArray(targetId, timeMs)
	self:CreateAbilityDataArrays(sourceId, targetId, abilityId, "dmgData")
	
	self.currentFightData["units"][sourceId]["dmg"] = self.currentFightData["units"][sourceId]["dmg"] + hitValue
	self.currentFightData["units"][targetId]["dmgRecieved"] = self.currentFightData["units"][targetId]["dmgRecieved"] + hitValue
	self.currentFightData["units"][sourceId]["dmgData"][targetId][abilityId]["value"] = self.currentFightData["units"][sourceId]["dmgData"][targetId][abilityId]["value"] + hitValue
end
function GroupDamage.onCombatEventDmg(_, _, _, _, _, _, sourceName, sourceType, targetName, targetType, hitValue, _, _, _, sourceUnitId, targetUnitId, abilityId)
	GroupDamage:UpdateUnitList(sourceUnitId, sourceName, sourceType)
	GroupDamage:UpdateUnitList(targetUnitId, targetName, targetType)
	if hitValue < 2 then return end
	
	GroupDamage:DmgDataCom(sourceUnitId, targetUnitId, GetGameTimeMilliseconds(), abilityId, hitValue)		
	GroupDamage.currentFightData["units"][sourceUnitId]["dmgData"][targetUnitId][abilityId]["hits"] = GroupDamage.currentFightData["units"][sourceUnitId]["dmgData"][targetUnitId][abilityId]["hits"]+1
	
end
function GroupDamage.onCombatEventDmgCrit(_, _, _, _, _, _, sourceName, sourceType, targetName, targetType, hitValue, _, _, _, sourceUnitId, targetUnitId, abilityId)
	GroupDamage:UpdateUnitList(sourceUnitId, sourceName, sourceType)
	GroupDamage:UpdateUnitList(targetUnitId, targetName, targetType)
	
	GroupDamage:DmgDataCom(sourceUnitId, targetUnitId, GetGameTimeMilliseconds(), abilityId, hitValue)
	GroupDamage.currentFightData["units"][sourceUnitId]["dmgData"][targetUnitId][abilityId]["crits"] = GroupDamage.currentFightData["units"][sourceUnitId]["dmgData"][targetUnitId][abilityId]["crits"]+1

end
--HEAL=================
function GroupDamage:HealDataCom(sourceId, targetId, timeMs, abilityId, hitValue)
	self:CreateUnitArray(sourceId, timeMs)
	self:CreateUnitArray(targetId, timeMs)
	self:CreateAbilityDataArrays(sourceId, targetId, abilityId, "healData")

	self.currentFightData["units"][sourceId]["heal"] = self.currentFightData["units"][sourceId]["heal"] + hitValue
	self.currentFightData["units"][targetId]["healRecieved"] = self.currentFightData["units"][targetId]["healRecieved"] + hitValue
	self.currentFightData["units"][sourceId]["healData"][targetId][abilityId]["value"] = self.currentFightData["units"][sourceId]["healData"][targetId][abilityId]["value"] + hitValue
end
function GroupDamage.onCombatEventHeal(_, _, _, _, _, _, sourceName, sourceType, targetName, targetType, hitValue, _, _, _, sourceUnitId, targetUnitId, abilityId)
	GroupDamage:UpdateUnitList(sourceUnitId, sourceName, sourceType)
	GroupDamage:UpdateUnitList(targetUnitId, targetName, targetType)
	if abilityId == 41467 or abilityId == 57466 or abilityId == 57468 then return end
	
	GroupDamage:HealDataCom(sourceUnitId, targetUnitId, GetGameTimeMilliseconds(), abilityId, hitValue)
	GroupDamage.currentFightData["units"][sourceUnitId]["healData"][targetUnitId][abilityId]["hits"] = GroupDamage.currentFightData["units"][sourceUnitId]["healData"][targetUnitId][abilityId]["hits"]+1
end
function GroupDamage.onCombatEventHealCrit(_, _, _, _, _, _, sourceName, sourceType, targetName, targetType, hitValue, _, _, _, sourceUnitId, targetUnitId, abilityId)
	GroupDamage:UpdateUnitList(sourceUnitId, sourceName, sourceType)
	GroupDamage:UpdateUnitList(targetUnitId, targetName, targetType)
	
	GroupDamage:HealDataCom(sourceUnitId, targetUnitId, GetGameTimeMilliseconds(), abilityId, hitValue)
	GroupDamage.currentFightData["units"][sourceUnitId]["healData"][targetUnitId][abilityId]["crits"] = GroupDamage.currentFightData["units"][sourceUnitId]["healData"][targetUnitId][abilityId]["crits"]+1
end
--EFFECT===============
function GroupDamage.onEffectChanged(_, _, _, _, unitTag, _, _, _, _, _, _, _, _, unitName, unitId, _)
	GroupDamage:UpdateUnitList(unitId, unitName, unitTag)
end

--EVENT COMMON=========
function GroupDamage:CreateUnitArray(unitId, timeMs)
	if self.currentFightData["units"][unitId] ~= nil then return end
	self.currentFightData["units"][unitId] = {
		["name"] 			= "#" .. unitId,
		["player"] 			= false,
		["group"] 			= false,
		["dmg"] 			= 0,
		["dps"] 			= 0,
		["heal"] 			= 0,
		["hps"] 			= 0,
		["firstAction"] 	= timeMs,
		["lastAction"] 		= timeMs,
		["dmgRecieved"]	 	= 0,
		["healRecieved"]	= 0,
		["dmgData"]			= {},
		["healData"]		= {},
	}
end	
function GroupDamage:CreateAbilityDataArrays(sourceId, targetId, abilityId, dataType)
	if self.currentFightData["units"][sourceId][dataType][targetId] == nil then
		self.currentFightData["units"][sourceId][dataType][targetId] = {}
	end
	if self.currentFightData["units"][sourceId][dataType][targetId][abilityId] == nil then
		self.currentFightData["units"][sourceId][dataType][targetId][abilityId] = {
			["hits"] = 0,
			["crits"] = 0,
			["value"] = 0
		}
	end
end
function GroupDamage:UpdateUnitList(unitId, unitName, unitType)
	if unitName == "" and unitType ~= 3 and unitType ~= 1 then return end
	if self.unitList[unitId] == nil then 
		self.unitList[unitId] = {
			["name"] = "#" .. unitId, 
			["player"] = false, 
			["group"] = false
		} 
	end
	if targetName ~= "" then
		self.unitList[unitId]["name"] = zo_strformat("<<C:1>>", unitName)
		if unitName:match("%^.x")~=nil then self.unitList[unitId]["player"] = true end
	end
	if unitType == 3 or unitType == 1 then
		self.unitList[unitId]["group"] = true
	end
end



--PERIODICAL UPDATE (updateHandler())
function GroupDamage:UpdatePanel()	
	self.control.title:SetText("GroupDamage")

	local displayType = "dmg"
	local perSecondType = "dps"
	local rankingUsed = "ranking"
	if self.displayMode == "heal" then
		self.control.title:SetText("GroupHeal")
		displayType = "heal"
		perSecondType = "hps"
		rankingUsed = "rankingHeal"
	end
	
	local dataArrayToUse = self.currentFightData
	if self.panelShownFight > 0 then
		dataArrayToUse = self.combatHistory[self.panelShownFight]
		self.control.title:SetText("GD	Fight: " .. self.panelShownFight .. "/" .. #self.combatHistory)
	end	
	
	local combinedDmg = 0
	local combinedDps = 0

	if self.svars.unitTypeToShow == "group" then
		for k,v in pairs(dataArrayToUse[rankingUsed]) do
			if	v["group"] then
				combinedDmg = combinedDmg + v[displayType]
				combinedDps = combinedDps + v[perSecondType]
			end
		end
	elseif self.svars.unitTypeToShow == "players" then
		for k,v in pairs(dataArrayToUse[rankingUsed]) do
			if	v["player"] then
				combinedDmg = combinedDmg + v[displayType]
				combinedDps = combinedDps + v[perSecondType]
			end
		end
	elseif self.svars.unitTypeToShow == "all" then
		for k,v in pairs(dataArrayToUse[rankingUsed]) do
			combinedDmg = combinedDmg + v[displayType]
			combinedDps = combinedDps + v[perSecondType]
		end
	end
	
	local i = 1
	local iBar = 1
	while iBar <= self.svars.numberBarsShown and i <= #dataArrayToUse[rankingUsed] do
		if self.svars.unitTypeToShow == "group" and dataArrayToUse[rankingUsed][i]["group"] or self.svars.unitTypeToShow == "players" and dataArrayToUse[rankingUsed][i]["player"] or self.svars.unitTypeToShow == "all" then
			self.control.barArea.bars[iBar].statusBar:SetValue(dataArrayToUse[rankingUsed][i][displayType]/combinedDmg*100)
			if dataArrayToUse[rankingUsed][i]["name"]:len() > 17 then
				self.control.barArea.bars[iBar].name:SetText(dataArrayToUse[rankingUsed][i]["name"]:sub(1,15) .. "...")
			else
				self.control.barArea.bars[iBar].name:SetText(dataArrayToUse[rankingUsed][i]["name"])
			end
			
			self.control.barArea.bars[iBar].value:SetText(("%d (%d) %03.01f%%"):format(dataArrayToUse[rankingUsed][i][displayType], dataArrayToUse[rankingUsed][i][perSecondType], dataArrayToUse[rankingUsed][i][displayType]/combinedDmg*100))
			iBar = iBar+1
		end
		i = i+1
	end
	self.control.infoArea.combatDmg:SetText((displayType .. ": %d"):format(combinedDmg))
	self.control.infoArea.combatDps:SetText((perSecondType .. ": %d"):format(combinedDps))
	if self.panelShownFight > 0 then
		self.control.infoArea.combatInfo:SetText(dataArrayToUse["combatStartClock"] .. " - " .. dataArrayToUse["combatEndClock"])
	elseif self.panelShownFight == -1 then
		self.control.infoArea.combatInfo:SetText("infinite")
	else
		self.control.infoArea.combatInfo:SetText("current combat")
	end	
	self.control.infoArea.combatTarget:SetText(dataArrayToUse["mainTarget"]["name"])
	
	local function prettyTime(timeMs)
		local minutes = math.floor(timeMs/60000)
		local seconds = (timeMs - minutes*60000)/1000
		return ("%d:%04.01f"):format(minutes,seconds)
	end
	if dataArrayToUse["combatTime"] ~= 0 then	
		self.control.infoArea.combatDuration:SetText(prettyTime(dataArrayToUse["combatTime"]))
	elseif dataArrayToUse["combatStart"] ~= 0 then
		local usableDur = GetGameTimeMilliseconds()-dataArrayToUse["combatStart"]
		self.control.infoArea.combatDuration:SetText(prettyTime(usableDur))
	else
		self.control.infoArea.combatDuration:SetText("0:00")
	end
	
	if self.displayMode == "dmg" then
		self.control.buttonDmgHeal.button:SetText("D")
		self.control.buttonDmgHeal.button:SetNormalFontColor(1, 0.5, 0.5, 1) 
		self.control.buttonDmgHeal.button:SetMouseOverFontColor(1, 0.6, 4, 0.6) 	
	else
		self.control.buttonDmgHeal.button:SetText("H")
		self.control.buttonDmgHeal.button:SetNormalFontColor(0.5, 1, 0.5, 1)
		self.control.buttonDmgHeal.button:SetMouseOverFontColor(0.5, 1, 0, 0.6)
	end
	if self.svars.unitTypeToShow == "group" then
		self.control.buttonType.button:SetText("G")
		self.control.buttonType.button:SetNormalFontColor(1, 0.6, 0.2, 1)
		self.control.buttonType.button:SetMouseOverFontColor(1, 0.6, 0.2, 0.6)		
	elseif self.svars.unitTypeToShow == "all"then
		self.control.buttonType.button:SetText("A")
		self.control.buttonType.button:SetNormalFontColor(1, 1, 1, 1)
		self.control.buttonType.button:SetMouseOverFontColor(1, 1, 1, 0.6)
	elseif self.svars.unitTypeToShow == "players" then
		self.control.buttonType.button:SetText("P")
		self.control.buttonType.button:SetNormalFontColor(0.2, 0.8, 1, 1)
		self.control.buttonType.button:SetMouseOverFontColor(0.2, 0.8, 1, 0.6)
	end
	
end

function GroupDamage:OrderCurrentRanking()
	self.currentFightData["ranking"] = nil
	self.currentFightData["ranking"] = {}
	self.currentFightData["rankingHeal"] = nil
	self.currentFightData["rankingHeal"] = {}
	
	local minDmgLimiter = 0
	local minHealLimiter = 0
	if self.currentFightData["ranking"][12] ~= nil then minDmgLimiter = self.currentFightData["ranking"][12]["dmg"] end
	if self.currentFightData["rankingHeal"][12] ~= nil then minHealLimiter = self.currentFightData["ranking"][12]["heal"] end
	
	for k,v in pairs(self.currentFightData["units"]) do
		if v["dmg"] > minDmgLimiter then table.insert(self.currentFightData["ranking"], {["name"]=v["name"], ["dmg"]=v["dmg"], ["dps"]=v["dps"], ["player"]=v["player"], ["group"]=v["group"], ["id"] = k} ) end
		if v["heal"] > minHealLimiter then table.insert(self.currentFightData["rankingHeal"], {["name"]=v["name"], ["heal"]=v["heal"], ["hps"]=v["hps"], ["player"]=v["player"], ["group"]=v["group"], ["id"] = k} ) end	
	end
	
	for rank=1, #self.currentFightData["ranking"] do
		local currentItem = self.currentFightData["ranking"][rank]
		local biggerItem = rank
		
		for k=rank+1, #self.currentFightData["ranking"] do
			if self.currentFightData["ranking"][k]["dmg"] > self.currentFightData["ranking"][biggerItem]["dmg"] then 
				biggerItem = k
			end
		end
		
		self.currentFightData["ranking"][rank] = self.currentFightData["ranking"][biggerItem]
		self.currentFightData["ranking"][biggerItem] = currentItem
	end	
  
	for rank=1, #self.currentFightData["rankingHeal"] do
		local currentItem = self.currentFightData["rankingHeal"][rank]
		local biggerItem = rank
		
		for k=rank+1, #self.currentFightData["rankingHeal"] do
			if self.currentFightData["rankingHeal"][k]["heal"] > self.currentFightData["rankingHeal"][biggerItem]["heal"] then 
				biggerItem = k
			end
		end
		
		self.currentFightData["rankingHeal"][rank] = self.currentFightData["rankingHeal"][biggerItem]
		self.currentFightData["rankingHeal"][biggerItem] = currentItem
	end
end
function GroupDamage:UpdateCombatData()
	for unit, values in pairs(self.currentFightData["units"]) do
		if self.unitList[unit] ~= nil then
			values["name"] = self.unitList[unit]["name"]
			values["player"] = self.unitList[unit]["player"]
			values["group"] = self.unitList[unit]["group"]
		end
		local cbtTime = 1000
		if self.currentFightData["combatTime"] ~= 0 then cbtTime = self.currentFightData["combatTime"] 
		elseif self.currentFightData["combatStart"] ~= 0 then cbtTime = GetGameTimeMilliseconds()-self.currentFightData["combatStart"] end
		 
		values["dps"] = math.ceil(values["dmg"]/cbtTime*1000)
		values["hps"] = math.ceil(values["heal"]/cbtTime*1000)
	end
end	
function GroupDamage:FillMainTarget()		
	for unitId,unit in pairs(self.currentFightData["units"]) do
		if unit["dmgRecieved"] > self.currentFightData["mainTarget"]["dmgRecieved"] then
			self.currentFightData["mainTarget"]["name"] = unit["name"]
			self.currentFightData["mainTarget"]["dmgRecieved"] = unit["dmgRecieved"]
			self.currentFightData["mainTarget"]["id"] = unitId
		end
	end
end
function GroupDamage:ClearOldFights()
	local fightsToRemove = #self.combatHistory - self.svars.fightsToSave
	if fightsToRemove > 0 then
		for i=1, fightsToRemove do
			table.remove(self.combatHistory, #self.combatHistory)
		end
	end
	if self.panelShownFight > #self.combatHistory then self.panelShownFight = #self.combatHistory end
end
function GroupDamage:UpdateMissingGroupMembers()
	local groupSize = GetGroupSize()
	local unknownMembers = groupSize	
	if self.svars.unitTypeToShow ~= "group" or self.svars.showGroupCheck == false then unknownMembers=0 groupSize=0 end
	
	local unknownMembersIterator = 1
	for i=1, groupSize do
		local isKnown = false	
		for k,v in pairs(self.unitList) do
			if v["name"] == GetUnitName("group" .. i) then 
				unknownMembers = unknownMembers-1
				isKnown = true
				break
			end
		end
		if not isKnown then
			self.control.missingGroup.labels[unknownMembersIterator]:SetText(GetUnitName("group" .. i))
			unknownMembersIterator = unknownMembersIterator+1
		end
	end	
	
	for i=1, 12 do
		if i <= unknownMembers and self.missingGrpVisibile then
			self.control.missingGroup.labels[i]:SetHidden(false)
		else
			self.control.missingGroup.labels[i]:SetHidden(true)
		end
	end
	
	if unknownMembers == 0 then self.control.missingGroup:SetHidden(true) else self.control.missingGroup:SetHidden(false) end
	self.control.missingGroup.text:SetText("Unknown from group: " .. unknownMembers .. "/" .. groupSize)
	
end

--USER FUNCTIONS
function GroupDamage:ClearCurrentFight()
	self.currentFightData["combatStart"] = 0
	self.currentFightData["combatEnd"] = 0
	self.currentFightData["combatTime"] = 0
	for k,v in pairs(self.currentFightData["ranking"]) do self.currentFightData["ranking"][k]=nil end
	self.currentFightData["ranking"] = nil
	self.currentFightData["ranking"] = {}
	self.currentFightData["mainTarget"] = {["name"] = "", ["dmgRecieved"] = 0}
	for k,v in pairs(self.currentFightData["units"]) do
		v["dmg"] = 0
		v["dps"] = 0
		v["heal"] = 0
		v["hps"] = 0		
	end
	for k,v in pairs(self.currentFightData["units"]) do 
		self.currentFightData["units"][k]=nil 
	end
	self:ResetPanelControls()	
end
function GroupDamage:ClearAll()		
	for i=1, #self.combatHistory do
		table.remove(self.combatHistory)
	end
	self.panelShownFight = 0
	self:ClearCurrentFight()
	self:UpdatePanel()
end
function GroupDamage:ClearHistoryFight()
	if self.panelShownFight > 0 then
		table.remove(self.combatHistory, self.panelShownFight)
		self.panelShownFight = self.panelShownFight-1
		self:ResetPanelControls()
		self:UpdatePanel()
	else
		self:ClearCurrentFight()
	end	
end

function GroupDamage:ToggleInfMode()
	if self.panelShownFight ~= -1 then
		self.svars.infinityMode = true
		self.panelShownFight = -1
		self.control.buttonInf.button:SetNormalFontColor(0.8,0.2,1,1)
		self.control.buttonInf.button:SetMouseOverFontColor(0.8,0.2,1,0.6)
		if self.currentFightData["combatEnd"] ~= 0 then
			table.insert(self.combatHistory, 1, deepcopy(self.currentFightData))
			self:clearCurrentFight()			
		end
		self:ResetPanelControls()
	else
		if self.currentFightData["combatStart"] ~= 0 then
			self.currentFightData["combatEnd"] = GetTimeStamp()
			self.currentFightData["combatEndClock"] = GetTimeString()
			self.currentFightData["combatTime"] = GetDiffBetweenTimeStamps(self.currentFightData["combatEnd"], self.currentFightData["combatStart"])
		end
		self.svars.infinityMode = false
		self.panelShownFight = 0
		self.control.buttonInf.button:SetNormalFontColor(1,1,1,1)
		self.control.buttonInf.button:SetMouseOverFontColor(1,1,1,1)
	end
	self:UpdatePanel()
end
function GroupDamage:ChangeShownFight(dir)
	if not self.svars.infinityMode then	
		if dir == "prev" and self.combatHistory[self.panelShownFight+1] ~= nil then
			self.panelShownFight = self.panelShownFight+1
		elseif dir == "next" and self.panelShownFight > 0 then
			self.panelShownFight = self.panelShownFight-1
		end
		self:ResetPanelControls()
	end
end
function GroupDamage:ChangeUnitTypeShown(unitType)
	if unitType ~= "" and unitType ~= nil then
		self.svars.unitTypeToShow = unitType
	else
		if self.svars.unitTypeToShow == "all" then
			self.svars.unitTypeToShow = "players"
		elseif self.svars.unitTypeToShow == "players" then
			self.svars.unitTypeToShow = "group"
		elseif self.svars.unitTypeToShow == "group" then
			self.svars.unitTypeToShow = "all"
		end
	end
	
	self:OrderCurrentRanking()	 
	self:ResetPanelControls()
end	
function GroupDamage:ChangeDisplayMode()
	if self.displayMode == "heal" then 
		self.displayMode = "dmg" 
		self.svars.displayMode = "dmg"
	else 
		self.displayMode = "heal" 
		self.svars.displayMode = "heal"
	end
	self:ResetPanelControls()
end

function GroupDamage.PanelHideShowCombat(inCombat)
	if inCombat and GroupDamage.svars.showOnCombatStart then GroupDamage:HidePanel(false) end
	if GroupDamage.svars.hideDuringCombat then GroupDamage:HidePanel(inCombat) end
	if not inCombat and GroupDamage.svars.hideOnCombatEnd then GroupDamage.closeAtMs = GetGameTimeMilliseconds()+GroupDamage.svars.hideAfter*1000 end	
end




--unused
function GroupDamage:MigrateToNewId(oldId, newId) --WIP
	-- if self.nameIdPairs[unitName] ~= nil and self.nameIdPairs[unitName] ~= unitId then
				-- self:MigrateToNewId(self.nameIdPairs[unitName], unitId)
			-- end
			-- self.nameIdPairs[unitName] = unitId

	d("Id for player or named mob changed!")
	d("Old name: " .. self.unitList[oldId]["name"] .. " with ID: " .. oldId)
	d("New name: " .. self.unitList[newId]["name"] .. " with ID: " .. newId)
	--migration to new id here
	self.unitList[oldId] = nil
	self.currentFightData["units"][oldId] = nil
end