local WM = WINDOW_MANAGER
local GD = GroupDamage

function GroupDamageStats:InitializeControls()

	--Main control container
	self.control = WM:GetControlByName("GroupDamageStatsControl")
	self.control:SetHeight(30)
	self.control:SetWidth(650)
	self.control:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, GD.svars.statsOffset["x"], GD.svars.statsOffset["y"])
	
	--Header
	self.control.header = WM:CreateControl("$(parent)Header", self.control, CT_CONTROL)
	self.control.header:SetAnchorFill()
	self.control.header.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.header, "GDBackdropFill")
	self.control.header.bg:SetCenterColor(GD.svars.panelHeaderColor[1], GD.svars.panelHeaderColor[2], GD.svars.panelHeaderColor[3], GD.svars.panelHeaderColor[4])
	self.control.header.title = WM:CreateControlFromVirtual("$(parent)Title", self.control.header, "GDLabel16")
	self.control.header.title:SetAnchorFill()
	self.control.header.title:SetText("GD Stats X-TREME alpha")	
	
	--Menu
	self.control.menu = WM:CreateControl("$(parent)Menu", self.control, CT_CONTROL)
	self.control.menu:SetAnchor(TOPLEFT, self.control.header, BOTTOMLEFT, 0, 0)
	self.control.menu:SetHeight(75)
	self.control.menu:SetWidth(250)
	self.control.menu.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.menu, "GDBackdropFill")
	self.control.menu.bg:SetCenterColor(0.1, 0.1, 0.1, 0.9)
	
	self.control.menu.testbutton = WM:CreateControl("$(parent)Testbutton", self.control.menu, CT_CONTROL)
	self.control.menu.testbutton:SetAnchor(TOPLEFT, self.control.menu, TOPLEFT, 6, 6)
	self.control.menu.testbutton:SetAnchor(BOTTOMRIGHT, self.control.menu, BOTTOMRIGHT, -6, -6)
	self.control.menu.testbutton.button = WM:CreateControlFromVirtual("$(parent)Button", self.control.menu.testbutton, "GDPanelButton")
	self.control.menu.testbutton.button:SetText("TEST")
	self.control.menu.testbutton.button:SetMouseOverFontColor(1, 0, 1, 1) 
	self.control.menu.testbutton.button:SetNormalFontColor(1, 1, 1, 1) 
	self.control.menu.testbutton.button:SetHandler("OnClicked", function() self:CreateCombatList() end)
	self.control.menu.testbutton.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.menu.testbutton, "GDPanelButtonBg")	
	
	--List
	
	self.control.list = WM:GetControlByName("GroupDamageStatsControlList")
	--self.control.list = WM:CreateControl("$(parent)List", self.control, CT_CONTROL)
	
	
	self.control.list:SetAnchor(TOPLEFT, self.control.menu, BOTTOMLEFT, 0, 1)
	self.control.list:SetAnchor(TOPRIGHT, self.control.menu, BOTTOMRIGHT, 0, 1)
	self.control.list:SetHeight(400)
	self.control.list.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.list, "GDBackdropFill")
	self.control.list.bg:SetCenterColor(0.1, 0.1, 0.1, 0.9)
	
	self.control.list.offset = 0
	self.control.list.maxItems = 13	
	self.control.list.dataItems = 20
	
	local tex = "/esoui/art/miscellaneous/scrollbox_elevator.dds"
    self.control.list.slider = WINDOW_MANAGER:CreateControl(nil, self.control.list, CT_SLIDER)
    self.control.list.slider:SetDimensions(20,self.control.list:GetHeight())
    self.control.list.slider:SetMouseEnabled(true)
	self.control.list.slider:SetMinMax(0, 0)
    self.control.list.slider:SetThumbTexture(tex,tex,tex,30,50,0,0,1,1)
    self.control.list.slider:SetValue(0)
    self.control.list.slider:SetValueStep(1)
    self.control.list.slider:SetAnchor(RIGHT,self.control.list,LEFT,0,0)
	
	self.control.list.slider:SetHandler("OnValueChanged", function(self, value)
        GroupDamageStats.control.list.offset = math.min(value,GroupDamageStats.control.list.dataItems - GroupDamageStats.control.list.maxItems)
        --UpdateHistoryWindow()
    end)
	
	self.control.list:SetHandler("OnMouseWheel",function(self,delta)
        local value = GroupDamageStats.control.list.offset - delta
        if value < 0 then 
            value = 0
        elseif value > GroupDamageStats.control.list.dataItems - GroupDamageStats.control.list.maxItems then 
            value = GroupDamageStats.control.list.dataItems - GroupDamageStats.control.list.maxItems 
        end
        GroupDamageStats.control.list.offset = value
        GroupDamageStats.control.list.slider:SetValue(GroupDamageStats.control.list.offset)
        --UpdateHistoryWindow()
    end)
	
	self.control.list.items = {}
	for i=1, self.control.list.maxItems do
		self.control.list.items[i] = WM:CreateControl("$(parent)Item"..i, self.control.list, CT_CONTROL)
		
		if i == 1 then
			self.control.list.items[i]:SetAnchor(TOPLEFT, self.control.list, TOPLEFT, 0, 0)
			self.control.list.items[i]:SetAnchor(TOPRIGHT, self.control.list, TOPRIGHT, 0, 0)
		else
			self.control.list.items[i]:SetAnchor(TOPLEFT, self.control.list.items[i-1], BOTTOMLEFT, 0, 0)
			self.control.list.items[i]:SetAnchor(TOPRIGHT, self.control.list.items[i-1], BOTTOMRIGHT, 0, 0)
		end
		self.control.list.items[i]:SetHeight(25)
		
		self.control.list.items[i].bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.list.items[i], "GDPanelButtonBg")
		
		self.control.list.items[i].button = WM:CreateControlFromVirtual("$(parent)Button", self.control.list.items[i], "GDPanelButton")
		self.control.list.items[i].button:SetText("")
		self.control.list.items[i].button:SetMouseOverFontColor(1, 1, 0.5, 0.8) 
		self.control.list.items[i].button:SetNormalFontColor(1, 1, 1, 1) 
		self.control.list.items[i].button:SetHandler("OnClicked", function() end)
		self.control.list.items[i].button.highlight = WM:CreateControlFromVirtual("$(parent)Highlight", self.control.list.items[i].button, "GDSButtonHighlight")
		self.control.list.items[i].button:SetHandler("OnMouseEnter", function() self.control.list.items[i].button.highlight:SetHidden(false) end)
		self.control.list.items[i].button:SetHandler("OnMouseExit", function() self.control.list.items[i].button.highlight:SetHidden(true) end)
	end
	
	--combat main info	
	self.control.combatInfo = WM:CreateControl("$(parent)Info", self.control, CT_CONTROL)
	self.control.combatInfo:SetAnchor(BOTTOMLEFT, self.control.menu, BOTTOMRIGHT, 1, 0)
	self.control.combatInfo:SetAnchor(TOPRIGHT, self.control.header, BOTTOMRIGHT, 0, 0)
	self.control.combatInfo.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.combatInfo, "GDBackdropFill")
	self.control.combatInfo.bg:SetCenterColor(0.1, 0.1, 0.1, 0.9)
	
	self.control.combatInfo.label = WM:CreateControlFromVirtual("$(parent)Title", self.control.combatInfo, "GDLabel16")
	self.control.combatInfo.label:SetAnchor(TOPLEFT, self.control.combatInfo, TOPLEFT,0,0)
	self.control.combatInfo.label:SetAnchor(TOPRIGHT, self.control.combatInfo, TOPRIGHT,0,0)
	self.control.combatInfo.label:SetHeight(25)
	self.control.combatInfo.label:SetText('Press "Test" and then select current fight!')
	
	--sorce -> target info
	self.control.combatInfo.sourceAndTarget = WM:CreateControlFromVirtual("$(parent)SourceTarget", self.control.combatInfo, "GDLabel16")
	self.control.combatInfo.sourceAndTarget:SetAnchor(TOP, self.control.combatInfo.label, BOTTOM, 0, 0)
	self.control.combatInfo.sourceAndTarget:SetAnchor(BOTTOM, self.control.combatInfo.overall, TOP, 0, 0)
	self.control.combatInfo.sourceAndTarget:SetText("This and the next line doesn't do anything.")
	
	self.control.combatInfo.overall = WM:CreateControlFromVirtual("$(parent)DmgDps", self.control.combatInfo, "GDLabel16")
	self.control.combatInfo.overall:SetAnchor(BOTTOMLEFT, self.control.combatInfo.combatInfo, BOTTOMLEFT, 0, 0)
	self.control.combatInfo.overall:SetAnchor(BOTTOMRIGHT, self.control.combatInfo.combatInfo, BOTTOMRIGHT, 0, 0)
	self.control.combatInfo.overall:SetHeight(25)
	self.control.combatInfo.overall:SetText("dmg: 0 - dps: 0 <> heal: 0 - hps: 0")
	
	
	--Body
	self.control.body = WM:CreateControl("$(parent)Body", self.control, CT_CONTROL)
	self.control.body:SetAnchor(TOPRIGHT, self.control.combatInfo, BOTTOMRIGHT, 0, 1)
	self.control.body:SetAnchor(BOTTOMLEFT, self.control.list, BOTTOMRIGHT, 1, 0)	
	self.control.body.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.body, "GDBackdropFill")
	self.control.body.bg:SetCenterColor(0.1, 0.1, 0.1, 0.9)
	
	--Tableheader
	self.control.body.tableHeader = WM:CreateControl("$(parent)TableHeader", self.control, CT_CONTROL)
	self.control.body.tableHeader:SetAnchor(TOPLEFT, self.control.body, TOPLEFT, 0, 0)
	self.control.body.tableHeader:SetAnchor(TOPRIGHT, self.control.body, TOPRIGHT, 0, 0)
	self.control.body.tableHeader:SetHeight(30)	
	self.control.body.tableHeader.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.body.tableHeader, "GDBackdropFill")
	self.control.body.tableHeader.bg:SetCenterColor(GD.svars.panelBgColor[1], GD.svars.panelBgColor[2], GD.svars.panelBgColor[3], GD.svars.panelBgColor[4])
	
	self.control.body.tableHeader.number = WM:CreateControlFromVirtual("$(parent)Number", self.control.body.tableHeader, "GDLabel18b")
	self.control.body.tableHeader.number:SetAnchor(LEFT, self.control.body.tableHeader, LEFT, 5, 0)
	self.control.body.tableHeader.number:SetWidth(25)
	self.control.body.tableHeader.number:SetText("")
	self.control.body.tableHeader.number:SetWrapMode(TRUNCATE) 
	self.control.body.tableHeader.number:SetHorizontalAlignment(0)
		
	self.control.body.tableHeader.name = WM:CreateControlFromVirtual("$(parent)Name", self.control.body.tableHeader, "GDLabel18b")
	self.control.body.tableHeader.name:SetAnchor(LEFT, self.control.body.tableHeader.number, RIGHT, 0, 0)
	self.control.body.tableHeader.name:SetWidth(150)
	self.control.body.tableHeader.name:SetHorizontalAlignment(0)
	self.control.body.tableHeader.name:SetText("Name")	
	
	self.control.body.tableHeader.value = WM:CreateControlFromVirtual("$(parent)Value", self.control.body.tableHeader, "GDLabel18b")
	self.control.body.tableHeader.value:SetAnchor(LEFT, self.control.body.tableHeader.name, RIGHT, 0, 0)
	self.control.body.tableHeader.value:SetWidth(60)
	self.control.body.tableHeader.value:SetHorizontalAlignment(0)
	self.control.body.tableHeader.value:SetText("Dmg")
	
	self.control.body.tableHeader.perSec = WM:CreateControlFromVirtual("$(parent)PerSec", self.control.body.tableHeader, "GDLabel18b")
	self.control.body.tableHeader.perSec:SetAnchor(LEFT, self.control.body.tableHeader.value, RIGHT, 0, 0)
	self.control.body.tableHeader.perSec:SetWidth(60)
	self.control.body.tableHeader.perSec:SetHorizontalAlignment(0)
	self.control.body.tableHeader.perSec:SetText("Dps")
	
	self.control.body.tableHeader.crit = WM:CreateControlFromVirtual("$(parent)Crit", self.control.body.tableHeader, "GDLabel18b")
	self.control.body.tableHeader.crit:SetAnchor(LEFT, self.control.body.tableHeader.perSec, RIGHT, 0, 0)
	self.control.body.tableHeader.crit:SetWidth(60)
	self.control.body.tableHeader.crit:SetHorizontalAlignment(0)
	self.control.body.tableHeader.crit:SetText("Crit")
	
	self.control.body.tableHeader.count = WM:CreateControlFromVirtual("$(parent)Count", self.control.body.tableHeader, "GDLabel18b")
	self.control.body.tableHeader.count:SetAnchor(LEFT, self.control.body.tableHeader.crit, RIGHT, 0, 0)
	self.control.body.tableHeader.count:SetWidth(60)
	self.control.body.tableHeader.count:SetHorizontalAlignment(0)
	self.control.body.tableHeader.count:SetText("#")
	
	--Ranking container
	self.control.body.ranking = WM:CreateControl("$(parent)Ranking", self.control.body, CT_CONTROL)
	self.control.body.ranking:SetAnchor(TOPLEFT, self.control.body.tableHeader, BOTTOMLEFT, 0, 5)
	self.control.body.ranking:SetAnchor(BOTTOMRIGHT, self.control.body, BOTTOMRIGHT, 0, 0)
	
	
	self.control.body.ranking.offset = 0
	self.control.body.ranking.maxItems = 13	
	self.control.body.ranking.dataItems = 20
	
	local tex = "/esoui/art/miscellaneous/scrollbox_elevator.dds"
    self.control.body.ranking.slider = WINDOW_MANAGER:CreateControl(nil, self.control.body.ranking, CT_SLIDER)
    self.control.body.ranking.slider:SetDimensions(20,self.control.body.ranking:GetHeight())
    self.control.body.ranking.slider:SetMouseEnabled(true)
	self.control.body.ranking.slider:SetMinMax(0, 11)
    self.control.body.ranking.slider:SetThumbTexture(tex,tex,tex,30,50,0,0,1,1)
    self.control.body.ranking.slider:SetValue(0)
    self.control.body.ranking.slider:SetValueStep(1)
    self.control.body.ranking.slider:SetAnchor(LEFT,self.control.body.ranking,RIGHT,0,0)
	
	self.control.body.ranking.slider:SetHandler("OnValueChanged", function(self, value)
        GroupDamageStats.control.body.ranking.offset = math.min(value,GroupDamageStats.control.body.ranking.dataItems - GroupDamageStats.control.body.ranking.maxItems)
        --UpdateHistoryWindow()
    end)
	
	self.control.body.ranking:SetHandler("OnMouseWheel",function(self,delta)
        local value = GroupDamageStats.control.body.ranking.offset - delta
        if value < 0 then 
            value = 0
        elseif value > GroupDamageStats.control.body.ranking.dataItems - GroupDamageStats.control.body.ranking.maxItems then 
            value = GroupDamageStats.control.body.ranking.dataItems - GroupDamageStats.control.body.ranking.maxItems 
        end
        GroupDamageStats.control.body.ranking.offset = value
        GroupDamageStats.control.body.ranking.slider:SetValue(GroupDamageStats.control.body.ranking.offset)
        --UpdateHistoryWindow()
    end)
	
	
	
	self.control.body.ranking.rank = {}
	for i=1, 10 do
		self.control.body.ranking.rank[i] = WM:CreateControl("$(parent)rank"..i, self.control.body.ranking, CT_CONTROL)
		
		if i == 1 then
			self.control.body.ranking.rank[i]:SetAnchor(TOPLEFT, self.control.body.ranking, TOPLEFT, 0, 0)
			self.control.body.ranking.rank[i]:SetAnchor(TOPRIGHT, self.control.body.ranking, TOPRIGHT, 0, 0)
		else
			self.control.body.ranking.rank[i]:SetAnchor(TOPLEFT, self.control.body.ranking.rank[i-1], BOTTOMLEFT, 0, 2)
			self.control.body.ranking.rank[i]:SetAnchor(TOPRIGHT, self.control.body.ranking.rank[i-1], BOTTOMRIGHT, 0, 2)
		end
		self.control.body.ranking.rank[i]:SetHeight(30)
		
		self.control.body.ranking.rank[i].bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.body.ranking.rank[i], "GDBackdropFill")
		self.control.body.ranking.rank[i].bg:SetCenterColor(1,1,1,0.2)
		
		self.control.body.ranking.rank[i].number = WM:CreateControlFromVirtual("$(parent)Number", self.control.body.ranking.rank[i], "GDLabel16")
		self.control.body.ranking.rank[i].number:SetAnchor(LEFT, self.control.body.ranking.rank[i], LEFT, 5, 0)
		self.control.body.ranking.rank[i].number:SetWidth(25)
		self.control.body.ranking.rank[i].number:SetHorizontalAlignment(0)
		
		self.control.body.ranking.rank[i].name = WM:CreateControlFromVirtual("$(parent)Name", self.control.body.ranking.rank[i], "GDLabel16")
		self.control.body.ranking.rank[i].name:SetAnchor(LEFT, self.control.body.ranking.rank[i].number, RIGHT, 0, 0)
		self.control.body.ranking.rank[i].name:SetWidth(150)
		self.control.body.ranking.rank[i].name:SetHorizontalAlignment(0)
		
		self.control.body.ranking.rank[i].value = WM:CreateControlFromVirtual("$(parent)Value", self.control.body.ranking.rank[i], "GDLabel16")
		self.control.body.ranking.rank[i].value:SetAnchor(LEFT, self.control.body.ranking.rank[i].name, RIGHT, 0, 0)
		self.control.body.ranking.rank[i].value:SetWidth(60)
		self.control.body.ranking.rank[i].value:SetHorizontalAlignment(0)
		
		self.control.body.ranking.rank[i].perSec = WM:CreateControlFromVirtual("$(parent)PerSec", self.control.body.ranking.rank[i], "GDLabel16")
		self.control.body.ranking.rank[i].perSec:SetAnchor(LEFT, self.control.body.ranking.rank[i].value, RIGHT, 0, 0)
		self.control.body.ranking.rank[i].perSec:SetWidth(60)
		self.control.body.ranking.rank[i].perSec:SetHorizontalAlignment(0)
		
		self.control.body.ranking.rank[i].crit = WM:CreateControlFromVirtual("$(parent)Crit", self.control.body.ranking.rank[i], "GDLabel16")
		self.control.body.ranking.rank[i].crit:SetAnchor(LEFT, self.control.body.ranking.rank[i].perSec, RIGHT, 0, 0)
		self.control.body.ranking.rank[i].crit:SetWidth(60)
		self.control.body.ranking.rank[i].crit:SetHorizontalAlignment(0)
		
		self.control.body.ranking.rank[i].count = WM:CreateControlFromVirtual("$(parent)Count", self.control.body.ranking.rank[i], "GDLabel16")
		self.control.body.ranking.rank[i].count:SetAnchor(LEFT, self.control.body.ranking.rank[i].crit, RIGHT, 0, 0)
		self.control.body.ranking.rank[i].count:SetWidth(60)
		self.control.body.ranking.rank[i].count:SetHorizontalAlignment(0)
		
		self.control.body.ranking.rank[i].button = WM:CreateControlFromVirtual("$(parent)Button", self.control.body.ranking.rank[i], "GDPanelButton")
		self.control.body.ranking.rank[i].button:SetText("")
		self.control.body.ranking.rank[i].button:SetHandler("OnClicked", function() end)
		self.control.body.ranking.rank[i].button.highlight = WM:CreateControlFromVirtual("$(parent)Highlight", self.control.body.ranking.rank[i].button, "GDSButtonHighlight")
		self.control.body.ranking.rank[i].button:SetHandler("OnMouseEnter", function() self.control.body.ranking.rank[i].button.highlight:SetHidden(false) end)
		self.control.body.ranking.rank[i].button:SetHandler("OnMouseExit", function() self.control.body.ranking.rank[i].button.highlight:SetHidden(true) end)
	end
	
	self.control.buttonClose = WM:CreateControl("$(parent)ButtonClose", self.control, CT_CONTROL)
	self.control.buttonClose:SetAnchor(TOPRIGHT, self.control, TOPRIGHT, -1, -1)
	self.control.buttonClose:SetWidth(23)
	self.control.buttonClose:SetHeight(23)
	self.control.buttonClose.button = WM:CreateControlFromVirtual("$(parent)Button", self.control.buttonClose, "GDPanelButton")
	self.control.buttonClose.button:SetText("X")
	self.control.buttonClose.button:SetMouseOverFontColor(1, 0, 0, 1) 
	self.control.buttonClose.button:SetNormalFontColor(1, 1, 1, 1) 
	self.control.buttonClose.button:SetHandler("OnClicked", function() self:HidePanel(true) end)
	self.control.buttonClose.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.buttonClose, "GDPanelButtonBg")	
	
	self.control.buttonDebug = WM:CreateControl("$(parent)ButtonDebug", self.control, CT_CONTROL)
	self.control.buttonDebug:SetAnchor(RIGHT, self.control.buttonClose, LEFT, -3, -3)
	self.control.buttonDebug:SetWidth(23)
	self.control.buttonDebug:SetHeight(23)
	self.control.buttonDebug.button = WM:CreateControlFromVirtual("$(parent)Button", self.control.buttonDebug, "GDPanelButton")
	self.control.buttonDebug.button:SetText("DB")
	self.control.buttonDebug.button:SetMouseOverFontColor(1, 0, 0, 1) 
	self.control.buttonDebug.button:SetNormalFontColor(1, 1, 1, 1) 
	self.control.buttonDebug.button:SetHandler("OnClicked", function() d("no ability array selected") end)
	self.control.buttonDebug.bg = WM:CreateControlFromVirtual("$(parent)Bg", self.control.buttonDebug, "GDPanelButtonBg")
	
end


function GroupDamageStats:ResetSources()
	for i=1, 10 do
		self.control.body.ranking.rank[i].number:SetText("")
		self.control.body.ranking.rank[i].name:SetText("")
		self.control.body.ranking.rank[i].value:SetText("")
		self.control.body.ranking.rank[i].perSec:SetText("")
		self.control.body.ranking.rank[i].crit:SetText("")
		self.control.body.ranking.rank[i].count:SetText("")
	end	
end

function GroupDamageStats:ResetList()
	for i=1, 10 do
		self.control.list.items[i].button:SetText("")
		self.control.list.items[i].button:SetMouseOverFontColor(1, 1, 0.5, 0.8) 
		self.control.list.items[i].button:SetNormalFontColor(1, 1, 1, 1) 
		self.control.list.items[i].button:SetHandler("OnClicked", function() end)
	end
end

function GroupDamageStats:HidePanel(inCombat)
	if inCombat then
		self.hudScene:RemoveFragment(self.panelFragment)
		self.hudUiScene:RemoveFragment(self.panelFragment)
		self.hudScene:RemoveFragment(self.panelFragmentList)
		self.hudUiScene:RemoveFragment(self.panelFragmentList)
		self.wasOpen = false
	else
		self.hudScene:AddFragment(self.panelFragment)
		self.hudUiScene:AddFragment(self.panelFragment)
		self.hudScene:AddFragment(self.panelFragmentList)
		self.hudUiScene:AddFragment(self.panelFragmentList)
		self.wasOpen = true
	end
end
function GroupDamageStats:OnDisplayPosChange()
	GD.svars.statsOffset["x"] = self.control:GetLeft()
	GD.svars.statsOffset["y"] = self.control:GetTop()
end